#!/bin/sh
ssh_exec() {
	ssh -p $port $host "$1"
	sleep 2
}




myname=$(basename $0)
#cfg="~/$myname/$1.asc"
cfg="$1.asc"
ssh_cmd="echo" #just a dummy since ';' on the beginning of the cmdline causes an error

if [ -f "$cfg" ]
then
	#nasty hack because gpg won't let it's output be eval'd (or I don't understand how it's done)
	config=$(gpg --no-mdc-warning -dq "$cfg")
	[ $? -ne 0 ] && exit
	for i in $config; do eval $i; done
elif [ -f "${cfg%.asc}" ]
then
	. "${cfg%.asc}"
else
	echo "hostconfig $cfg non-existant."
	echo
	echo "Usage: $myname cfg_file"
	exit
fi

echo "Connecting to $host:$port to check ssh host key."
echo "Simply type exit if it's ok, otherwise break with CTRL-C"
ssh_exec
[ $? -ne 0 ] && exit


idx=0
eval src=\$cmd_${idx}_src
eval dst=\$cmd_${idx}_dst
eval pwd=\$cmd_${idx}_pwd
while [ -n "$src" ]
do
	if [ -n "$dst" ]
	then
		ssh_cmd="$ssh_cmd ; echo $pwd | cryptsetup -T1 luksOpen $src $dst"
	else
		ssh_cmd="$ssh_cmd ; vgchange -ay $src"
	fi
	let "idx += 1"
	eval src=\$cmd_${idx}_src
	eval dst=\$cmd_${idx}_dst
	eval pwd=\$cmd_${idx}_pwd
done

ssh_cmd="$ssh_cmd ; killall cryptsetup"
ssh_exec "$ssh_cmd"
